```
<
def main_testing(dicom_T2_path):

    output_path = './media/output/'

    # remove all the exsiting files for current case testing
    for file in os.listdir(output_path):
        os.remove(os.path.join(output_path,file))

    # preprocess a T2 dicom to raw png, and save the png in "./media/convert_img/T2"
    image_path = preprocessing(dicom_T2_path,dicom_T2_path.split('/')[-1]) #image_path: raw T2 png path
    
    # save T2 png, prostate_roi.png, T2_with contour.png under output folder
    x1, y1, x2, y2 = predict(image_path)

    # return malignacy and save './media/output/T2_lesion.png'
    prostate_roi_T2_path='./media/output/prostate_roi.png'
    malignancy_T2 = predict_malignancy_T2(prostate_roi_T2_path,image_path)
    
    malignancy_ADC=malignancy_T2
    malignancy_BVAL=malignancy_T2

    adc_dicom = os.listdir('./media/upload/ADC/')
    if len(adc_dicom)==1:
        if os.path.isfile(os.path.join('./media/upload/ADC/',adc_dicom[0])):  
            if adc_dicom[0].endswith("dcm"):
                dicom_ADC_path = os.path.join('./media/upload/ADC/', adc_dicom[0])

                # save raw png, raw png with contour,and cropped prostate png under './media/output/'
                adc_transform(dicom_ADC_path, dicom_T2_path, x1, y1, x2, y2)

                prostate_roi_ADC_path = './media/output/adc_crop.png'
                prostate_ADC_path = './media/output/adc.png'

                if os.path.exists(prostate_roi_ADC_path):
                    malignancy_ADC = predict_malignancy_ADC(prostate_roi_ADC_path)
                else:
                    malignancy_ADC = predict_malignancy_ADC(prostate_ADC_path)

    bval_dicom = os.listdir('./media/upload/BVAL/')
    if len(bval_dicom)==1:
        if os.path.isfile(os.path.join('./media/upload/BVAL/',bval_dicom[0])):  
            if bval_dicom[0].endswith("dcm"):
                dicom_BVAL_path = os.path.join('./media/upload/BVAL/', bval_dicom[0])

                # save raw png, raw png with contour,and cropped prostate png under './media/output/'
                bval_transform(dicom_BVAL_path, dicom_T2_path, x1, y1, x2, y2)

                prostate_roi_BVAL_path = './media/output/bval_crop.png'
                prostate_BVAL_path = './media/output/bval.png'

                if os.path.exists(prostate_roi_BVAL_path):
                    malignancy_BVAL = predict_malignancy_BVAL(prostate_roi_BVAL_path)
                else:
                    malignancy_BVAL = predict_malignancy_BVAL(prostate_BVAL_path)

    malignancy = np.argmax(malignancy_T2 + malignancy_ADC + malignancy_BVAL)
    # print('malignancy:', malignancy)
    return malignancy>
    
def predict_malignancy_T2(prostate_roi,raw_image_path):

    if os.path.exists(prostate_roi):

        image=Image.open(prostate_roi).convert('L')
        image = image.resize((224, 224))
        img=np.array(image)/255
        
        model = sinnet_share('./doc/weights/weight2_1.h5')
        model.load_weights('./doc/weights/weight2_2.h5')

        aa = img.reshape(1, 224, 224, 1)
        out_0_2 = model.predict([aa,aa])
        
        del model
        K.clear_session()
        gc.collect()
        
        raw_image_RGB = np.array(image.convert('RGB'))
        pred_mask = Image.fromarray(255*out_0_2[0][0][:,:,0]).convert("L")
        pred_mask = np.array(pred_mask)

        ret, binary = cv2.threshold(pred_mask, 40, 255, cv2.THRESH_BINARY)  # second para is threhold
        contours, hierarchy = cv2.findContours(binary, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
        
        if np.size(contours) != 0:
            #method 1
            contour = max(contours, key = cv2.contourArea)
            image_with_contour = cv2.drawContours(raw_image_RGB,[contour],-1, color=(0, 255, 255),lineType = cv2.LINE_AA,thickness=-1)
            #method 2
            #image_with_contour = cv2.drawContours(raw_image_RGB, [contours[0]], -1, color=(0, 0, 255),thickness=-1)
            
            # draw pred mask
            image_with_contour = cv2.addWeighted(raw_image_RGB,1,image_with_contour,0.3,0)  
            # save final label and pred result
            cv2.imwrite('./media/output/T2_lesion.png',image_with_contour)
        else:
            # print("np.size(contours)= 0")
            pass
        print('done predict_malignancy_T2!')

        return out_0_2[1][0]
    else:

        image=Image.open(raw_image_path).convert('L')
        image = image.resize((224, 224))
        img=np.array(image)/255
        
        model = sinnet_share('./doc/weights/weight2_1.h5')
        model.load_weights('./doc/weights/weight2_2.h5')

        aa = img.reshape(1, 224, 224, 1)
        out_0_2 = model.predict([aa,aa])
        
        del model
        K.clear_session()
        gc.collect()
       
        return out_0_2[1][0]

def predict_malignancy_ADC(prostate_roi):
    
    image=Image.open(prostate_roi).convert('L')
    image = image.resize((224, 224))
    img=np.array(image)/255
    
    model = sinnet_share('./doc/weights/weight3_1.h5')
    model.load_weights('./doc/weights/weight3_2.h5')

    aa = img.reshape(1, 224, 224, 1)
    out_0_2 = model.predict([aa,aa])
    
    del model
    K.clear_session()
    gc.collect()
    
    # print('ADC done!')
    return out_0_2[1][0]

def predict_malignancy_BVAL(prostate_roi):
    
    image=Image.open(prostate_roi).convert('L')
    image = image.resize((224, 224))
    img=np.array(image)/255
    
    model = sinnet_share('./doc/weights/weight4_1.h5')
    model.load_weights('./doc/weights/weight4_2.h5')

    aa = img.reshape(1, 224, 224, 1)
    out_0_2 = model.predict([aa,aa])
    
    del model
    K.clear_session()
    gc.collect()
    
    # print('BVAL done!')
    return out_0_2[1][0]
```